﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=9.3
@EndOfDesignText@
Sub Class_Globals
	Private fx As JFX
	
	Private nativeMe, pc As JavaObject
	
	Public LPosition_InsideNW As Int
	Public LPosition_InsideNE As Int
	Public LPosition_InsideSE As Int
	Public LPosition_InsideSW As Int
	Public LPosition_InsideN As Int
	Public LPosition_InsideS As Int
	Public LPosition_OutsideS As Int
	
	Public LLayout_Horizontal As Int
	Public LLayout_Vertical As Int
	
'	Public ClockwiseDirection_Clockwise As Int
'	Public ClockwiseDirection_Counter_Clockwise As Int
	
	Public labelType_Value As Int
	Public labelType_Percentage As Int
	Public labelType_Name As Int
	Public labelType_NameAndPercentage As Int
	Public labelType_NameAndValue As Int
	Public PieSeriesRenderStyle_Donut As Int
	Public PieSeriesRenderStyle_Pie As Int
	Dim eventname As String
		
End Sub

'Initializes the object. You can add parameters to this method if needed.
Public Sub initializePieChart(e As String, wdth As Int, hght As Int, ttl As String)
	
	eventname = e
	LPosition_InsideNW = 1
	LPosition_InsideNE = 2
	LPosition_InsideSE = 3
	LPosition_InsideSW = 4
	LPosition_InsideN = 5
	LPosition_InsideS = 6
	LPosition_OutsideS = 7
	
	LLayout_Horizontal = 1
	LLayout_Vertical = 2
	
'	ClockwiseDirection_Clockwise = 1
'	ClockwiseDirection_Counter_Clockwise = 2
	
	labelType_Value = 1
	labelType_Percentage = 2
	labelType_Name = 3
	labelType_NameAndPercentage = 4
	labelType_NameAndValue = 5
	
	PieSeriesRenderStyle_Pie = 1
	PieSeriesRenderStyle_Donut = 2
		
	nativeMe = Me
	
	'In the line below --->>>> Main.obj1.GetModuleBA("Main") = get the BA of the Main module and pass it to the inline java code
	nativeMe.RunMethod("initPieChart", Array(Main.obj1.GetModuleBA("Main"), eventname, wdth, hght, ttl))
	
End Sub
 
'set the text color of the lables
public Sub setLabelsFontColor(labelFontColor As JavaObject)
	
	nativeMe.RunMethod("setLabelsFontColor", Array(labelFontColor))
	
End Sub

'set the label  type to display 
'can be one of the following:
'	labelType_Value = 1
'	labelType_Percentage = 2
'	labelType_Name = 3
'	labelType_NameAndPercentage = 4
'	labelType_NameAndValue = 5
public Sub setLabelType(labeltype As Int)
	
	nativeMe.RunMethod("setLabelType", Array(labeltype))
End Sub

'draw the pie chart
public Sub drawPieChart As JavaObject
	
	pc = nativeMe.RunMethod("drawChart", Null)
	Return pc
	
End Sub

'set the graph to be circular or to follow the width/height of the pane
'the default value is true
public Sub setGraphCircular(circ As Boolean)
	
	nativeMe.RunMethod("setCircular", Array(circ))
	
End Sub

'add a series to the pie chart
public Sub addSeries(name As String, value As Double)
	
	nativeMe.RunMethod("addSeries", Array(name, value))
	
End Sub

'remove a series - pass the name of the series
public Sub removeSeries(name As String)
	
	nativeMe.RunMethod("removeSeries", Array(name))
	
End Sub

'set the colors of the pie slices
'<code>
'Dim slice1ColorObject, slice2ColorObject, slice3ColorObject As JavaObject   'using JavaObject to pass an instance of java.awt.Color for the pie slice colors
'	
'slice1ColorObject.InitializeNewInstance("java.awt.Color", Array(255, 0, 0))         'color of slice/series 1
'slice2ColorObject.InitializeNewInstance("java.awt.Color", Array(0, 255, 0))         'color of slice/series 2
'slice3ColorObject.InitializeNewInstance("java.awt.Color", Array(0, 0, 255))         'color of slice/series 3
'	
'Dim sliceColorArray As JavaObject
'sliceColorArray.InitializeArray("java.awt.Color", Array(slice1ColorObject, slice2ColorObject, slice3ColorObject))
'piechart.SliceColors = sliceColorArray
'</code>
public Sub setSliceColors(col As JavaObject)
	
	nativeMe.RunMethod("setSliceColors", Array(col))
	
End Sub

'set the start angle of the pie chart
'the default value is 0 degrees
public Sub setStartAngle(angle As Int)
	nativeMe.RunMethod("setStartAngle", Array(angle))
	
End Sub

'set tooltips enabled
'the default value is false 
public Sub setToolTipsEnabled (tooltipEnabled As Boolean)
	
	nativeMe.RunMethod("setToolTipEnabled", Array(tooltipEnabled))
	
End Sub

'set the border width of the pie slices
'the default value is 10
public Sub setSliceBorderWidth (borderWidth As Int)
	
	nativeMe.RunMethod("setSliceBorderWidth", Array(borderWidth))
	
End Sub

'set the legend position
public Sub setLegendPosition(position As Int)
	
	nativeMe.RunMethod("setLegendPosition", Array(position))
	
End Sub

'set the layout of the Legend to Vertical or Horizontal
public Sub setLegendLayout(layout As Int)
	
	nativeMe.RunMethod("setLegendLayout", Array(layout))
	
End Sub

'make the legend visible / not visible
'default value is true
public Sub setLegendVisible(visible As Boolean)
	
	nativeMe.RunMethod("setLegendVisible", Array(visible))
	
End Sub

'set visibility of the sum of the slices
'default value is false
public Sub setSumVisible(sumVisible As Boolean)
	
	nativeMe.RunMethod("setSumVisible", Array(sumVisible))
	
End Sub

'Sets the content size of the plot inside the plot area of the chart. To fill the area 100%, use a value of 1.0.
'The default value is 0.9
public Sub setPlotContentSize (size As Double)
	
	nativeMe.RunMethod("setPlotContentSize", Array(size))
	
End Sub

'set the background color of the plot area
public Sub setPlotBackgroundColor(backColor As JavaObject)
	
	nativeMe.RunMethod("setPlotBackgroundColor", Array(backColor))
	 
End Sub

'set the border color of the plot area
public Sub setPlotBorderColor(plotBorderColor As JavaObject)
	
	nativeMe.RunMethod("setPlotBorderColor", Array(plotBorderColor))
	 
End Sub

'set the visibility of the labels
'default value is TRUE
public Sub setLabelsVisible(labelVisible As Boolean)
		
		nativeMe.RunMethod("setLabelsVisible", Array(labelVisible))
	
End Sub


'set the style to Pie or to Donut
'The default is Pie
public Sub setPieSeriesRenderStyle(style As Int)
	
	nativeMe.RunMethod("setPieSeriesRenderStyle", Array(style))
	
End Sub

'Set the thickness of the donut ring for donut style pie chart series.
'Valid range Is between 0 And 1
'Default value is 0.33
public Sub setDonutTickness(thick As Double)
	
	nativeMe.RunMethod("setDonutThickness", Array(thick))
	
End Sub

'update the value of a series
public Sub updatePieSeries(seriesName As String, seriesValue As Double)

	nativeMe.RunMethod("setUpdatePieSeries", Array(seriesName, seriesValue))
	
End Sub

'repaint the chart after an update of a series
public Sub repaintChart()
	
	nativeMe.RunMethod("repaintChart", Null)
End Sub

'Sets the distance of the pie chart's annotation where 0 is the center, 1 is at the edge and greater than 1 is outside of the pie chart.
Public Sub setLabelsDistance(distance As Double)
	
	nativeMe.RunMethod("setLabelsDistance", Array(distance))
	
End Sub

'set the font for the text of the labels
'<code>
'Dim fontType As JavaObject
'fontType.InitializeStatic("java.awt.Font")
'Dim labelFont As JavaObject
'labelFont.InitializeNewInstance("java.awt.Font", Array(fontType.GetField("DIALOG"), fontType.GetField("HANGING_BASELINE"), 12))   'MONOSPACED, SANS_SERIF, SERIF, DIALOG, DIALOG_INPUT
'                                                                                                                                  'BOLD, PLAIN, CENTER_BASELINE, HANGING_BASELINE, ITALIC, TRUETYPE_FONT, TYPE1_FONT, ROMAN_BASELINE
'piechart.LabelsFont = labelFont
'</code>
public Sub setLabelsFont(lblfnt As JavaObject)
	
	nativeMe.RunMethod("setLabelsFont", Array(lblfnt))
	
End Sub


'set the chart title font
public Sub setChartTitleFont(ttlfnt As JavaObject)
	
	nativeMe.RunMethod("setChartTitleFont", Array(ttlfnt))
	
End Sub

'Set the chart font color. Includes: Chart title, axes label, legend
Public Sub setChartFontColor(chartFontColor As JavaObject)
	
	nativeMe.RunMethod("setChartFontColor", Array(chartFontColor))
	
End Sub

'set the background color of the legend
Public Sub setLegendBackgroundColor(lbgc As JavaObject)
	
	nativeMe.RunMethod("setLegendBackgroundColor", Array(lbgc))
	
End Sub

'set the border color of the legend
Public Sub setLegendBorderColor(lbc As JavaObject)
	
	nativeMe.RunMethod("setLegendBorderColor", Array(lbc))
	
End Sub

'set the font of the legend
Public Sub setLegendFont(fnt As JavaObject)
	
	nativeMe.RunMethod("setLegendFont", Array(fnt))
	
End Sub

'set the background color of the title box
Public Sub setChartTitleBoxBackgroundColor(ctbbc As JavaObject)
	nativeMe.RunMethod("setChartTitleBoxBackgroundColor", Array(ctbbc))
End Sub

'set the color of the title box	border
Public Sub setChartTitleBoxBorderColor(ccbbc As JavaObject)
	nativeMe.RunMethod("setChartTitleBoxBorderColor", Array(ccbbc))
End Sub


'set the TitleBoxVisible to true / false
Public Sub setChartTitleBoxVisible(visible As Boolean)
	
	nativeMe.RunMethod("setChartTitleBoxVisible", Array(visible))
	
End Sub

'set the tooltip background color
Public Sub setToolTipBackgroundColor (ttbgc As JavaObject)
	
	nativeMe.RunMethod("setToolTipBackgroundColor", Array(ttbgc))
	
End Sub

'set the tooltip border color
Public Sub setToolTipBorderColor (ttbc As JavaObject)
	
	nativeMe.RunMethod("setToolTipBorderColor", Array(ttbc))
	
End Sub

'set the font of the tooltip
Public Sub setToolTipFont(fnt As JavaObject)
	
	nativeMe.RunMethod("setToolTipFont", Array(fnt))
	
End Sub

Private Sub myevent_fire (tooltipinfo As Object)
	
	Try
		CallSubDelayed2(Main, eventname & "_chartvalue_clicked", tooltipinfo)      'call/raise event in xxx_chartvalue_clicked of module Main
	Catch
		Log("ERROR = " & LastException)
	End Try
	
End Sub

Private Sub myevent_mouse_pressed (nothing As String)
	
	Try
		CallSubDelayed2(Main, eventname & "_mouse_pressed", nothing)      'call/raise event in xxx_chartvalue_clicked of module Main
	Catch
		Log("ERROR = " & LastException)
	End Try
	
End Sub

Private Sub myevent_mouse_released (nothing As String)
	
	Try
		CallSubDelayed2(Main, eventname & "_mouse_released", nothing)      'call/raise event in xxx_chartvalue_clicked of module Main
	Catch
		Log("ERROR = " & LastException)
	End Try
	
End Sub

Private Sub myevent_mouse_exited (nothing As String)
	
	Try
		CallSubDelayed2(Main, eventname & "_mouse_exited", nothing)      'call/raise event in xxx_chartvalue_clicked of module Main
	Catch
		Log("ERROR = " & LastException)
	End Try
	
End Sub

Private Sub myevent_mouse_entered (nothing As String)
	
	Try
		CallSubDelayed2(Main, eventname & "_mouse_entered", nothing)      'call/raise event in xxx_chartvalue_clicked of module Main
	Catch
		Log("ERROR = " & LastException)
	End Try
	
End Sub


'set the direction to draw the pie chart i.e clockwise or counter clockwise
'public Sub setClockwiseDirectionType(direction As Int)
'	
'	nativeMe.RunMethod("setClockwiseDirectionType", Array(direction))
'	
'End Sub


#If Java

import org.knowm.xchart.PieChart;
import org.knowm.xchart.PieChartBuilder;
import org.knowm.xchart.style.Styler;
import javafx.scene.Node;
import javax.swing.JPanel;
import java.awt.Color;

import org.knowm.xchart.QuickChart;
import org.knowm.xchart.XChartPanel;
import org.knowm.xchart.XYChart;
import org.knowm.xchart.XYChartBuilder;
import org.knowm.xchart.XYSeries.XYSeriesRenderStyle;
import org.knowm.xchart.internal.chartpart.Chart;
import org.knowm.xchart.style.Styler.LegendPosition;
import org.knowm.xchart.style.PieStyler.ClockwiseDirectionType;
import javafx.embed.swing.SwingNode;
import javafx.scene.layout.StackPane;
import javafx.scene.layout.Pane;
import java.awt.Font;

import org.knowm.xchart.internal.chartpart.ToolTips;
import org.knowm.xchart.style.PieStyler.LabelType;
import org.knowm.xchart.PieSeries.PieSeriesRenderStyle;

import java.awt.event.MouseAdapter;
import java.awt.event.MouseMotionAdapter;
import java.awt.event.MouseEvent;

import java.awt.event.MouseMotionListener;
import java.awt.event.MouseListener;
import anywheresoftware.b4a.keywords.Common;

	private BA ba;
	XChartPanel chartPanel;
	Color[] sliceColors;

	public void setSliceColors (Color[] sliceColors) {
		this.sliceColors = sliceColors;
		chart.getStyler().setSeriesColors(sliceColors);	
	}
	
	String oldstring = "";
		
	private int wdth = 400;
	private int hght = 400;
	private String graphTitle = "";

	private boolean circ = true;
	public void setCircular(boolean circ) {
		chart.getStyler().setCircular(circ);
	}	
	
	String EventName = "";
	PieChart chart;
	public void initPieChart(BA ba, String EventName,int wdth, int hght, String graphTitle) {
		this.EventName = EventName;
		chart = new PieChartBuilder().width(wdth).height(hght).title(graphTitle).build();
		this.ba = ba;
	}
	
	public Object drawChart() {
	    
		SwingNode swingNode = new SwingNode();	
	    chartPanel = new XChartPanel(chart);
	    swingNode.setContent(chartPanel);	
		Pane pane = new Pane();
		pane.getChildren().add(swingNode);
			
		chartPanel.addMouseListener(new MouseAdapter() {

	            @Override
	            public void mousePressed(MouseEvent e) {
				    try { 
				  			 _myevent_mouse_pressed("");     //TAKE NOTE OF THIS SUB BEING CALLED IN THE B4J CLASS ABOVE - NAMES MUST MATCH AND PREECEDED BY "_"
						     
					}  catch (Exception fnuckup) {
					
						 	 BA.Log("Fnuckup = " + fnuckup);
					}								   
					
					if (chartPanel.getToolTips().getSelectedTooltipData() != null) {
					   String myString = "" + chartPanel.getToolTips().getSelectedTooltipData();
					   if (!oldstring.equals(myString)) {
					   		oldstring = myString;
						    try { 
						  			 _myevent_fire(myString);     //TAKE NOTE OF THIS SUB BEING CALLED IN THE B4J CLASS ABOVE - NAMES MUST MATCH AND PREECEDED BY "_"
								     
							}  catch (Exception fnuckup) {
							
								 	 BA.Log("Fnuckup = " + fnuckup);
							}								   
					    }	
					 }	  					
	            }

	            @Override
	            public void mouseReleased(MouseEvent e) {
				    try { 
				  			 _myevent_mouse_released("");     //TAKE NOTE OF THIS SUB BEING CALLED IN THE B4J CLASS ABOVE - NAMES MUST MATCH AND PREECEDED BY "_"
						     
					}  catch (Exception fnuckup) {
					
						 	 BA.Log("Fnuckup = " + fnuckup);
					}		
	            }
				
				@Override
				public void mouseExited(MouseEvent e) {
				    try { 
				  			 _myevent_mouse_exited("");     //TAKE NOTE OF THIS SUB BEING CALLED IN THE B4J CLASS ABOVE - NAMES MUST MATCH AND PREECEDED BY "_"
						     
					}  catch (Exception fnuckup) {
					
						 	 BA.Log("Fnuckup = " + fnuckup);
					}		
				}
				
				@Override
				public void mouseEntered(MouseEvent e) {
				    try { 
				  			 _myevent_mouse_entered("");     //TAKE NOTE OF THIS SUB BEING CALLED IN THE B4J CLASS ABOVE - NAMES MUST MATCH AND PREECEDED BY "_"
						     
					}  catch (Exception fnuckup) {
					
						 	 BA.Log("Fnuckup = " + fnuckup);
					}		
				}

	        });		
			 
		return pane;	
	}	
	 
	public void repaintChart() {
		chartPanel.repaint();
	}
	
	public void addSeries(String name, double value) {
		chart.addSeries(name, value);
	}
	
	public void removeSeries(String name) {
		chart.removeSeries(name);
	}	
	
	private int borderWidth = 10;
	public void setSliceBorderWidth (int borderWidth) {
		this.borderWidth = borderWidth;
		chart.getStyler().setSliceBorderWidth(borderWidth);
	}
	
	int layout = 1;
	public void setLegendLayout(int layout) {
		this.layout = layout;
		if (layout == 1) chart.getStyler().setLegendLayout(Styler.LegendLayout.Horizontal);
		if (layout == 2) chart.getStyler().setLegendLayout(Styler.LegendLayout.Vertical);
	}
	
	private boolean visible = true;
	public void setLegendVisible (boolean visible) {
		this.visible = visible;
		chart.getStyler().setLegendVisible(visible);
	}
	
	private boolean sumVisible = false;
	public void setSumVisible (boolean sumVisible) {
		this.sumVisible = sumVisible;
		chart.getStyler().setSumVisible(sumVisible);
	}
	
	private double plotContentSize = 0.9;
	public void setPlotContentSize(double plotContentSize) {
		this.plotContentSize = plotContentSize;
		chart.getStyler().setPlotContentSize(plotContentSize);	
	}
	
	public void setPlotBackgroundColor(Color backGroundColor) {
		chart.getStyler().setPlotBackgroundColor(backGroundColor);	
	}
	
	public void setPlotBorderColor(Color borderColor) {
		chart.getStyler().setPlotBorderColor(borderColor);	
	}
	
	public void setLabelType(int labelType) {
	
		if (labelType == 1) chart.getStyler().setLabelType(LabelType.Value);
		if (labelType == 2) chart.getStyler().setLabelType(LabelType.Percentage);
		if (labelType == 3) chart.getStyler().setLabelType(LabelType.Name);
		if (labelType == 4) chart.getStyler().setLabelType(LabelType.NameAndPercentage);
		if (labelType == 5) chart.getStyler().setLabelType(LabelType.NameAndValue);
	}
	
	//the clockwise method does not seem to do what it should do - it breaks the slices into smaller pieces......?
/*	public void setClockwiseDirectionType(int clockwise) {
		if (clockwise == 1) chart.getStyler().setClockwiseDirectionType(ClockwiseDirectionType.CLOCKWISE);
		if (clockwise == 2) chart.getStyler().setClockwiseDirectionType(ClockwiseDirectionType.COUNTER_CLOCKWISE);
	}
*/	
		
 	public void setLabelsDistance(double distance) {
		chart.getStyler().setLabelsDistance(distance);
	}
 
 	private int style = 1;
 	public void setPieSeriesRenderStyle(int style) {
		if (style == 1) chart.getStyler().setDefaultSeriesRenderStyle(PieSeriesRenderStyle.Pie);
		if (style == 2) chart.getStyler().setDefaultSeriesRenderStyle(PieSeriesRenderStyle.Donut);
	}
	
  	private double donutThickness = 0.33;
	public void setDonutThickness(double donutThickness) {
		this.donutThickness = donutThickness;
		chart.getStyler().setDonutThickness(donutThickness);
	}
	
	public void setUpdatePieSeries(String seriesName, Number value) {
		chart.updatePieSeries(seriesName, value);
	}
	
	public void setLabelsFontColor(Color labelsFontColor) {
		chart.getStyler().setLabelsFontColorAutomaticEnabled(false);
		chart.getStyler().setLabelsFontColor(labelsFontColor);	
	}
	
	public void setLabelsFont(Font labelFont) {
		chart.getStyler().setLabelsFont(labelFont);
	}
	
	public void setChartTitleFont(Font titleFont) {
		chart.getStyler().setChartTitleFont(titleFont);
		
	}	
	
	public void setChartTitleBoxVisible(boolean visible) {
		chart.getStyler().setChartTitleBoxVisible(visible);
	}
	
	public void setChartFontColor(Color chartFontColor) {
		chart.getStyler().setChartFontColor(chartFontColor);
	}
	
 	private boolean labelVisible = true;
 	public void setLabelsVisible(boolean labelVisible) {
		this.labelVisible = labelVisible;
		chart.getStyler().setLabelsVisible(labelVisible);
	}
	
	private int pos = 7;
	public void setLegendPosition(int pos) {
		this.pos = pos;
		if (pos == 1) chart.getStyler().setLegendPosition(Styler.LegendPosition.InsideNW);
		if (pos == 2) chart.getStyler().setLegendPosition(Styler.LegendPosition.InsideNE);
		if (pos == 3) chart.getStyler().setLegendPosition(Styler.LegendPosition.InsideSE);
		if (pos == 4) chart.getStyler().setLegendPosition(Styler.LegendPosition.InsideSW);
		if (pos == 5) chart.getStyler().setLegendPosition(Styler.LegendPosition.InsideN);
		if (pos == 6) chart.getStyler().setLegendPosition(Styler.LegendPosition.InsideS);
		if (pos == 7) chart.getStyler().setLegendPosition(Styler.LegendPosition.OutsideS);
		
	}
	
	private int startAngle = 0;
	public void setStartAngle(int startAngle) {
		this.startAngle = startAngle;
		chart.getStyler().setStartAngleInDegrees(startAngle);
	}
	
	private boolean tooltipEnabled = false;
	public void setToolTipEnabled(boolean tooltipEnabled) {
	 	this.tooltipEnabled = tooltipEnabled;
		chart.getStyler().setToolTipsEnabled(tooltipEnabled);	
	}
	
	public void setLegendBackgroundColor(Color lbgc) {
		chart.getStyler().setLegendBackgroundColor(lbgc);
	}
	
	public void setLegendBorderColor(Color lbc) {
		chart.getStyler().setLegendBorderColor(lbc);
	}
	
	public void setLegendFont(Font legendFont) {
		chart.getStyler().setLegendFont(legendFont);
	}	
	
	public void setChartTitleBoxBackgroundColor(Color ctbbc) {
		chart.getStyler().setChartTitleBoxBackgroundColor(ctbbc);
	}
	
	public void setChartTitleBoxBorderColor(Color ccbbc) {
		chart.getStyler().setChartTitleBoxBorderColor(ccbbc);
	}
	
	public void setToolTipBackgroundColor(Color ttbgc) {
		chart.getStyler().setToolTipBackgroundColor(ttbgc);
	}
	
	public void setToolTipBorderColor(Color ttbc) {
		chart.getStyler().setToolTipBorderColor(ttbc);
	}
	
	public void setToolTipFont(Font toolTipFont) {
		chart.getStyler().setToolTipFont(toolTipFont);
	}		
	
#End If
